#include <core>
#include <string>
#include <admin>
#include <adminlib>
#include <plugin>

#define ACCESS_CONSOLE	131071

new STRING_VERSION[MAX_DATA_LENGTH] = "1.0";

/////////////////////////
// change it if you want 
/////////////////////////

new g_maxTAround=5; //player gets slayed, if he makes to many TAs in round
new g_round_check=8; //player is not allowed to make TAs after Round Start

/////////////////////////

#define CT		1
#define TERROR	2
#define SPEC	6

new g_Team[MAX_PLAYERS];
new g_RoundTA[MAX_PLAYERS];
new g_round;


public plugin_init(){
	plugin_registerinfo("CZ Anti-Teamattack Plugin","Punishs player, if he attacks teammate",STRING_VERSION);
	plugin_registercmd("admin_teamcheck", "admin_teamcheck", ACCESS_ALL);
	plugin_registercmd("logd_teamselect", "logd_teamselect", ACCESS_CONSOLE);
	plugin_registercmd("logd_injure", "logd_injure", ACCESS_CONSOLE);
	plugin_registercmd("logd_world","logd_world",ACCESS_CONSOLE);
	exec( "logd_reg 54 admin_command logd_teamselect" );
	exec( "logd_reg 58 admin_command logd_injure" );
	exec( "logd_reg 62 admin_command logd_world" );  
	return PLUGIN_CONTINUE;
}

				
public logd_teamselect(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new sTeam[MAX_NAME_LENGTH];
	new sID[3];
	new iID;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	strsep(Data," ",sID,3,sTeam,MAX_NAME_LENGTH);
	iID=strtonum(sID);
	if(playerinfo(iID,User,MAX_NAME_LENGTH)){
		if(strcmp(sTeam,"CT")==0){
			g_Team[iID]=CT;
		}else if(strcmp(sTeam,"TERRORIST")==0){
			g_Team[iID]=TERROR;
		}else if(strcmp(sTeam,"SPECTATOR")==0){
			g_Team[iID]=SPEC;
		}
	}
	return PLUGIN_CONTINUE;
}

public logd_injure(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new Attacker[MAX_NAME_LENGTH];
	new Victim[MAX_NAME_LENGTH];
	new Weapon[MAX_NAME_LENGTH];
	new sATT[3];
	new sVIC[3];
	new iATT;
	new iVIC;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
		
	strsep(Data," ",sATT,3,sVIC,3,Weapon,MAX_NAME_LENGTH);
	
	iATT=strtonum(sATT);
	iVIC=strtonum(sVIC);
	if(g_Team[iATT]==g_Team[iVIC]){
		say("Teamattack");
		if(playerinfo(iATT,Attacker,MAX_NAME_LENGTH)){
			if(playerinfo(iVIC,Victim,MAX_NAME_LENGTH)){
				g_RoundTA[iATT]+=1;
				if(g_round || g_RoundTA[iATT]>=g_maxTAround){
					snprintf(Data,MAX_DATA_LENGTH,"[ANTI-TA] Don't attack your teammate!");
					messageex(Attacker,Data,print_tty);
					slay(Attacker);
					g_RoundTA[iATT]=0;
				}else{
					snprintf(Data,MAX_DATA_LENGTH,"[ANTI-TA] Don't attack your teammate! (%i of %i)",g_RoundTA[iATT],g_maxTAround);
					messageex(Attacker,Data,print_tty);
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public logd_world(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_NAME_LENGTH];
   	convert_string(HLData,Data,MAX_NAME_LENGTH); 
	if(Data[0]=='G' || Data[8]=='R'){
		reset_array(0);
	}else if(Data[6]=='S'){
		reset_array(0);
		g_round=1;
		set_timer("check_start",g_round_check,0);
	}
	return PLUGIN_CONTINUE;
}

public check_start(Timer,Repeat,HLName,HLParam) {
	g_round=0;
	return PLUGIN_CONTINUE;
}

reset_array(UserIndex){
	new i;
	new maxplayers=maxplayercount();
	if(!UserIndex){
		for(i=1;i<=maxplayers;i++){
			g_RoundTA[i]=0;
		}
	}else{
		g_RoundTA[UserIndex]=0;
		g_Team[UserIndex]=0;
	}
}
	
public plugin_connect(HLUserName,HLIP, UserIndex){
	reset_array(UserIndex);
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex){
	reset_array(UserIndex);
	return PLUGIN_CONTINUE;
}

public admin_teamcheck(HLCommand,HLData,HLUserName,UserIndex) {
	new Text[MAX_TEXT_LENGTH];
	new Player[MAX_NAME_LENGTH];
	new AuthID[MAX_AUTHID_LENGTH];
	new i;
	new iTeam;
	new maxplayers=maxplayercount();	
	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Player,MAX_NAME_LENGTH,_,_,iTeam,_,AuthID)){
			snprintf(Text,MAX_TEXT_LENGTH,"[CHECK 1:] %s -- Team: %i -- AUTHID: %s",Player,iTeam,AuthID);
			selfmessage(Text);
			strinit(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"[CHECK 2:] %s -- Team: %i -- AUTHID: %s",Player,g_Team[i],AuthID);
			selfmessage(Text);
			strinit(Text);
			selfmessage("----");
		}
	}
	return PLUGIN_HANDLED;
}